=== debian/changelog ===
libical3 (3.0.19-3) unstable; urgency=medium

  * Upload to unstable (Closes: #1091461)

 -- Nicolas Mora <babelouest@debian.org>  Wed, 08 Jan 2025 16:30:21 -0500

libical3 (3.0.19-2) experimental; urgency=medium

  * d/patches: Add patch to fix build on hppa and powerpc

 -- Nicolas Mora <babelouest@debian.org>  Mon, 06 Jan 2025 11:13:23 -0500

libical3 (3.0.19-1) unstable; urgency=medium

  * New upstream release
  * d/lintian-overrides: ignore package-name-doesnt-match-sonames libical3

 -- Nicolas Mora <babelouest@debian.org>  Wed, 25 Dec 2024 11:18:53 -0500
