=== debian/changelog ===
libical3 (3.0.20-2) unstable; urgency=medium

  [Helmut Grohne]
  * Fix FTCBFS: (Closes: #1117667)
    + Explicitly supply triplet-prefixed vapigen and valac.
    + Skip gtk-doc in arch-only build.

  [Nicolas Mora]
  * d/watch: upgrade to version 5
  * d/control: upgrade standards version to 4.7.2
  * d/control: Remove Rules-Requires-Root: no

 -- Nicolas Mora <babelouest@debian.org>  Fri, 03 Oct 2025 07:27:33 -0400

libical3 (3.0.20-1) unstable; urgency=medium

  * New upstream release
  * d/patches: Remove patch to fix build on hppa and powerpc,
    applied updtream

 -- Nicolas Mora <babelouest@debian.org>  Mon, 10 Mar 2025 20:54:05 -0400

libical3 (3.0.19-4) unstable; urgency=medium

  [Nicolas Mora]
  * d/control: remove builddep gobject-introspection-bin
    (Closes: #1094623)

  [Simon McVittie]
  * d/control: Improve GObject-Introspection handling

 -- Nicolas Mora <babelouest@debian.org>  Sat, 01 Feb 2025 11:36:57 -0500
