=== debian/control ===
--- 
+++ 
@@ -5,12 +5,13 @@
 Build-Depends: dpkg-dev (>= 1.22.5),
   debhelper-compat (= 13),
   cmake,
+  gir1.2-glib-2.0-dev,
+  gir1.2-gobject-2.0-dev,
   gobject-introspection,
-  gobject-introspection-bin,
   tzdata,
   libicu-dev,
-  libgirepository1.0-dev,
   libdb-dev,
+  libglib2.0-dev,
   libglib2.0-dev:native,
   libxml2-dev,
   libxml2-dev:native,
@@ -18,11 +19,10 @@
   python3-gi <!nocheck>,
   gtk-doc-tools,
   doxygen
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/libical/libical
 Vcs-Browser: https://salsa.debian.org/debian/libical3
 Vcs-Git: https://salsa.debian.org/debian/libical3.git
-Rules-Requires-Root: no
 
 Package: libical-dev
 Section: libdevel
@@ -30,12 +30,14 @@
 Multi-Arch: same
 Depends: gir1.2-ical-3.0 (= ${binary:Version}),
   libical3t64 (= ${binary:Version}),
+  ${gir:Depends},
   ${misc:Depends},
   libicu-dev,
   libdb-dev,
 Breaks: libical3-dev (<< 3.0.1-5)
 Replaces: libical3-dev (<< 3.0.1-5)
-Provides: libical3-dev
+Provides: libical3-dev,
+          ${gir:Provides},
 Description: iCalendar library implementation in C (development)
  libical is an open source implementation of the IETF's iCalendar calendaring
  and scheduling protocols (RFC 2445, 2446, and 2447). It parses iCal components
@@ -78,7 +80,7 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${gir:Depends}, ${misc:Depends}, ${shlibs:Depends}
-Provides: gir1.2-icalglib-3.0
+Provides: ${gir:Provides}
 Description: iCalendar library implementation in C (GObject Introspection)
  libical is an open source implementation of the IETF's iCalendar calendaring
  and scheduling protocols (RFC 2445, 2446, and 2447). It parses iCal components
