=== debian/watch ===
Version: 5
Template: Github
Owner: libical
Project: libical
